﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//This script is responsible for blocking background actions when UI is active
public class BackgroundBlocker : MonoBehaviour {

	[Tooltip("A list of UI elements that will invoke the background block.")]
	public List<GameObject> ui = new List<GameObject>();
	void Update () {

		var block = false;

		foreach (GameObject ui in ui) {

			if (ui.activeSelf) {
				block = true;
				break;
			}

			block = false;
		}

		if (block) {
			ReferenceHolder.core.ClickBlocker.SetActive(true);
		} else {
			ReferenceHolder.core.ClickBlocker.SetActive(false);
		}

	}
}

//Tsenkilidis Alexandros - Cination