﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//This script handles click events
public class ClickManager : MonoBehaviour {

	//Creating reference
	public static ClickManager core;

	//initiating reference
	void Awake() {
		if (core == null) {
			core = this;
		}
	}

	void Update () {

		//if left mouse button has been clicked
		if (Input.GetMouseButtonDown(0)) {
			
			//let's detect what exactly has been clicked
			Vector2 point = Camera.main.ScreenToWorldPoint(Input.mousePosition);
			//Creating the raycast. Note that a mask is being applied with "~" being used to exclude a specific layer. The latter layer is only used for movement direction detection.
        	RaycastHit2D h = Physics2D.Raycast(point, Vector2.zero, Mathf.Infinity, ~(1 << LayerMask.NameToLayer("MovementCatcher")));

			if (h) {
				//clicking the ground (causing the player to move)
				switch (h.collider.gameObject.tag) {
					case ("Ground"):
						if (Movement.core.playerCanMove) {
							Movement.core.coordinates = point;
							Movement.core.Move();
						}
						break;
					case ("Item"):
						if (ItemInteractionManager.core.playerCanInteract) { ItemInteractionManager.core.pickUpItem (h); }
						break;
					case ("Entity"):
						if (EntityInteractionManager.core.playerCanInteract) { EntityInteractionManager.core.interact (h); }
						break;
					case ("Player"):
						//what happens when player is clicked
						break;
					default:
						break;
				}
			}
		}

	}

}

//Tsenkilidis Alexandros - Cination