﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class CursorUIDetector : MonoBehaviour {

	//Used to let the engine know that the cursor has previously entered a ui element
	private bool hasEntered = false;
		
	void Update () {
		
		//cursor hovers
		Vector2 point = Camera.main.ScreenToWorldPoint(Input.mousePosition);
		RaycastHit2D h = Physics2D.Raycast(point, Vector2.zero, Mathf.Infinity, ~(1 << LayerMask.NameToLayer("MovementCatcher")));

		//checking if gameobject contains a button
		if (h && h.collider.gameObject.GetComponent<Button>() != null) {

			CursorChanger.core.switchCursor (false);
			hasEntered = true;

		} else if (hasEntered) {

			//outside of buttons, switch cursor back
			CursorChanger.core.switchCursor (true);

			hasEntered = false;
		}
	}
}
