﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EntityInteractionManager : MonoBehaviour {

	public static EntityInteractionManager core;

	[Tooltip("Can the player interact with entities ?")]
	public bool playerCanInteract = true;

	[Tooltip("The furthest the entity can be to still be interactable.")]
	public float maximumDistanceFromPlayer = 5f;

	public void interact (RaycastHit2D h) {

		//player
		GameObject player = GameObject.FindWithTag("Player");

		//entity
		GameObject entityObject = h.collider.gameObject;

		//check distance to item
		var distance = Vector2.Distance(player.transform.position, entityObject.transform.position);

		if (distance <= maximumDistanceFromPlayer) {
			entityObject.GetComponent<Entity>().interact();
		}
	}

	void Awake () {
		if (core == null) {
			core = this;
		}
	}

}

//Tsenkilidis Alexandros - Cination
