﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

//This script should be attached to all items in-game
public class Item : MonoBehaviour {

	[Tooltip("The id of the item in the Database (Database.cs).")]
	public int id;
	[Tooltip("A unique identifier used to dispawn items that have been already picked up when loading scenes.")]
	public int instanceId;
	[Tooltip("Can the item be picked up ?.")]
	public bool canBePickedUp;

	private bool sw = false;

	//Checking if mouse is over item and displaying item name
	void Update() {
		
		Vector2 point = Camera.main.ScreenToWorldPoint(Input.mousePosition);
		RaycastHit2D h = Physics2D.Raycast(point, Vector2.zero, Mathf.Infinity, ~(1 << LayerMask.NameToLayer("MovementCatcher")));

		if (h && h.collider.gameObject == this.gameObject) {

			sw = true;

			var itemIndex = SupportFunctions.core.findItemIndexById(id);
			if (itemIndex != -1) {
				//name
				SupportFunctions.core.displayName(Database.core.items[itemIndex].name, false);
				//cursor
				CursorChanger.core.switchCursor (false);
			} else {
				Debug.Log ("Wrong item id " + id.ToString());
			}
		
		} else if (sw) {
			sw = false;
			//name
			SupportFunctions.core.displayName(null, true);
			//cursor
			CursorChanger.core.switchCursor (true);
		}
		

	}

	//If the item has been already picked up , disable it
	void Start () {

		//disable item if it has been already picked up
		if (Database.core.items[SupportFunctions.core.findItemIndexById(id)].pickedUpInstanceIds.Contains(instanceId)) {
			this.gameObject.SetActive(false);
		}

	}
	
}

//Tsenkilidis Alexandros - Cination