﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

//function dump
public class SupportFunctions : MonoBehaviour {

	public static SupportFunctions core;

	//text object to be used to display entity name
	public GameObject entityLabel;

	//open and close a gameObject
	public void toggle (GameObject g) {
		if (g.activeSelf) {
			g.SetActive (false);
		} else {
			g.SetActive (true);
		}
	}

	public void close (GameObject g) {
		g.SetActive(false);
	}


	//this function Destroys all child objects
	public void clear (GameObject g) {
		foreach (Transform c in g.transform) {
			Destroy (c.gameObject);
		}
	}

	public int findItemIndexById (int id) {
		var counter = 0;
		foreach (items item in Database.core.items) {
			if (item.id == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	public int findItemMetaIndexById (int id) {
		var counter = 0;
		foreach (itemsMeta item in Database.core.itemsMeta) {
			if (item.existingItemId == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	public int findEntityIndexById (int id) {
		var counter = 0;
		foreach (entities entity in Database.core.entities) {
			if (entity.entityId == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	public int findQuestIndexById (int id) {
		var counter = 0;
		foreach (quests quest in Database.core.quests) {
			if (quest.questId == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	public int findBuildSettingsIndexById (int id) {
		foreach (locations location in Database.core.locations) {
			if (location.id == id) {
				return location.buildSettingsIndex;
			}
		}
		
		return -1;
	}

	public int findIdByBuildSettingsIndex (int index) {
		foreach (locations location in Database.core.locations) {
			if (location.buildSettingsIndex == index) {
				return location.id;
			}
		}
		
		return -1;
	}

	public string findLocationNameById (int id) {
		foreach (locations location in Database.core.locations) {
			if (location.id == id) {
				return location.name;
			}
		}
		
		return "unknown";
	}

	public int findStepClipIndexById (int id) {
		var counter = 0;
		foreach (stepSound step in Database.core.stepSounds) {
			if (step.id == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	public int findMusicClipIndexById (int id) {
		var counter = 0;
		foreach (backgroundMusic music in Database.core.music) {
			if (music.id == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	public int findOptionIndexById (int id, GameObject scriptSource) {
		var counter = 0;
		foreach (options op in scriptSource.GetComponent<Entity>().options) {
			if (op.optionId == id) {
				return counter;
			} else {
				counter++;
			}
		}

		return -1;
	}

	public int findAmbienceClipIndexById (int id) {
		var counter = 0;
		foreach (backgroundAmbience ambience in Database.core.ambience) {
			if (ambience.id == id) {
				return counter;
			} else {
				counter++;
			}
		}
		
		return -1;
	}

	//display name ()
	public void displayName (string s, bool hide) {
		
		if (!hide) {
			entityLabel.GetComponent<Text>().text = s;
			entityLabel.SetActive(true);
		} else {
			entityLabel.SetActive(false);
		}
		
	}

	void Awake () {
		if (core == null) {
			core = this;
		}
	}
}

//Tsenkilidis Alexandros - Cination